/******************************************************************************
 *
 * Copyright:
 *    (C) 2005 Embedded Artists AB
 *
 * File:
 *    irq.c
 *
 * Description:
 *    Sample irq code, that must be compiled in ARM code.
 *
 *****************************************************************************/

/******************************************************************************
 * Includes
 *****************************************************************************/
#include "../general.h"
#include <lpc2xxx.h>
#include "irq.h"

/******************************************************************************
 * External variables
 *****************************************************************************/
extern void (*pDelayCallback)(void);
extern volatile tU8 timeoutExpired;

/*****************************************************************************
 * Local function prototypes
 ****************************************************************************/
void timer0ISR(void) __attribute__ ((interrupt));


/*****************************************************************************
 * Implementation of public functions
 ****************************************************************************/

/*****************************************************************************
 *
 * Description:
 *    Actual timer ISR that is called whenever timer 0 generated an interrupt.
 *
 ****************************************************************************/
void
timer0ISR(void)
{
  //call delay callback, if registered
  if (pDelayCallback != NULL)
    (*pDelayCallback)();

  timeoutExpired = TRUE;

  T0IR        = 0xff;        //reset all IRQ flags
  VICVectAddr = 0x00;        //dummy write to VIC to signal end of interrupt
}
